"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.setErrorHandler = exports["default"] = void 0;
var _index = require("../index");
var handler = null;
var setErrorHandler = function setErrorHandler(errorHandler) {
  handler = errorHandler;
};

/**
 * Provides a catch-all function for all requests. If the catch-all
 * function returns `true` it prevents the original promise to continue.
 */
exports.setErrorHandler = setErrorHandler;
var GlobalErrorHandlerMiddleware = function GlobalErrorHandlerMiddleware() {
  return {
    response: function response(next) {
      if (!_index.configs.Promise) {
        return next();
      }
      return new _index.configs.Promise(function (resolve, reject) {
        next().then(function (response) {
          return resolve(response);
        })["catch"](function (response) {
          var proceed = true;
          handler && (proceed = !(handler(response) === true));
          proceed && reject(response);
        });
      });
    }
  };
};
var _default = GlobalErrorHandlerMiddleware;
exports["default"] = _default;