"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.responseFactory = void 0;
var _response = require("../response");
var _requestFactory = require("./request-factory");
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
/**
 * Create a response to use in tests
 * @returns Response
 */
var responseFactory = function responseFactory() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
    _ref$method = _ref.method,
    method = _ref$method === void 0 ? 'GET' : _ref$method,
    _ref$host = _ref.host,
    host = _ref$host === void 0 ? 'http://example.org' : _ref$host,
    _ref$path = _ref.path,
    path = _ref$path === void 0 ? '/path' : _ref$path,
    _ref$request = _ref.request,
    request = _ref$request === void 0 ? (0, _requestFactory.requestFactory)({
      method: method,
      host: host,
      path: path
    }) : _ref$request,
    _ref$status = _ref.status,
    status = _ref$status === void 0 ? 200 : _ref$status,
    _ref$data = _ref.data,
    data = _ref$data === void 0 ? {} : _ref$data,
    _ref$headers = _ref.headers,
    headers = _ref$headers === void 0 ? {} : _ref$headers,
    _ref$errors = _ref.errors,
    errors = _ref$errors === void 0 ? [] : _ref$errors;
  var responseData;
  var contentType;
  if (typeof data === 'string') {
    contentType = 'text/plain';
    responseData = data;
  } else {
    contentType = 'application/json';
    responseData = JSON.stringify(data);
  }
  return new _response.Response(request, status, responseData, _objectSpread({
    'content-type': contentType
  }, headers), errors);
};
exports.responseFactory = responseFactory;