"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.clone = void 0;
var _index = require("./index");
var clone = function clone(obj) {
  if ((0, _index.isPlainObject)(obj)) {
    return cloneObject(obj);
  } else if (Array.isArray(obj)) {
    return cloneArray(obj);
  } else {
    return obj;
  }
};
exports.clone = clone;
var cloneObject = function cloneObject(obj) {
  var clone = {};
  for (var i in obj) {
    var value = obj[i];
    if ((0, _index.isObject)(value)) {
      clone[i] = cloneObject(value);
    } else if (Array.isArray(value)) {
      clone[i] = cloneArray(value);
    } else {
      clone[i] = value;
    }
  }
  return clone;
};
var cloneArray = function cloneArray(obj) {
  var clone = [];
  for (var i in obj) {
    var value = obj[i];
    if ((0, _index.isObject)(value)) {
      clone.push(cloneObject(value));
    } else if (Array.isArray(value)) {
      clone.push(cloneArray(value));
    } else {
      clone.push(value);
    }
  }
  return clone;
};